#載入 tcoreapi
from tcoreapi_mq import * 
#載入我們提供的行情 function
from quote_functions import *
import threading

#建立 ZMQ 連線

#設定連線授權碼，通常不用改。
g_QuoteZMQ = QuoteAPI("ZMQ","8076c9867a372d2a9a814ae710c256e2")

#設定連接 Port，通常不用改 3.0 = 51237, 4.0 = 50774。
#如果無法連線，可能是 port 被占用，可以到 TC安裝路徑\APPs\TCoreRelease\Logs 找日期最新的 QuoteZMQService-xxxxxx-0.log
#搜尋  RepPort: ，即可取得連線 Port
q_data = g_QuoteZMQ.Connect("50774")

if q_data["Success"] != "OK":
    #連線失敗。
    print("[ quote ]connection failed")
    print("連線失敗!\n可能是 port 被占用，請到 TC安裝路徑\\APPs\\TCoreRelease\\Logs \n找日期最新的 QuoteZMQService-xxxxxx-0.log 搜尋  RepPort: ，即可取得連線 Port")
else:

    #連線成功后，將取得的 Session Key 儲存下來，後面調用指令需要帶入。
    g_QuoteSession = q_data["SessionKey"]

    #建立一個執行緒用來處理即時行情與歷史資料
    thread_stop = False
    t1 = threading.Thread(target = quote_sub_th,args=(g_QuoteZMQ,q_data["SubPort"], lambda: thread_stop))
    t1.start()
    
    #實時行情訂閱
    #設定合約代碼，測試時請注意範例的合約是否已經下市。
    #使用 HOT 可以取得最新合約即時數據
    testSymbol = "TC.F.TWF.MXF.HOT"


    #訂閱實時行情
    g_QuoteZMQ.SubQuote(g_QuoteSession, testSymbol)

    print("即時 Greeks 數據展示中....")

    for i in range(10):
        time.sleep( 0.5 )

    print("展示完成....")
    thread_stop = True

    #解除訂閱
    g_QuoteZMQ.UnsubGreeks(g_QuoteSession, testSymbol)

    #斷開連線
    g_QuoteZMQ.Logout(g_QuoteSession)
    print("中斷連線中...")

#####################
#    即時行情欄位表  #
#####################

# {
#商品代碼 	                    'Symbol': 'TC.F.TWF.MXF.202201', 
#交易所代碼                     'Exchange': 'TWF', 
#交易所名稱                     'ExchangeName': '台灣期交所', 
#商品ID 	                    'Security': 'FIMTX', 
#商品名稱 	                    'SecurityName': '小臺', 
#商品類別 	                    'SecurityType': '6', 
#成交單量 	                    'TradeQuantity': '1', 
#成交時間 	                    'FilledTime': '23305', 
#交易日期 	                    'TradeDate': '20220104', 
#內外盤	                        'FlagOfBuySell': '2', 
#開盤時間 	                    'OpenTime': '84500', 
#收盤時間 	                    'CloseTime': '50000', 
#買量#1 	                    'BidVolume': '14', 
#買量#2 	                    'BidVolume1': '29', 
#買量#3 	                    'BidVolume2': '34', 
#買量#4 	                    'BidVolume3': '29', 
#買量#5 	                    'BidVolume4': '22', 
#買量#6 	                    'BidVolume5': '0', 
#買量#7 	                    'BidVolume6': '0', 
#買量#8 	                    'BidVolume7': '0', 
#買量#9 	                    'BidVolume8': '0', 
#買量#10 	                    'BidVolume9': '0', 
#賣價#1 	                    'AskVolume': '20', 
#賣價#2 	                    'AskVolume1': '37', 
#賣價#3 	                    'AskVolume2': '30', 
#賣價#4 	                    'AskVolume3': '38', 
#賣價#5 	                    'AskVolume4': '60', 
#賣價#6 	                    'AskVolume5': '0', 
#賣價#7 	                    'AskVolume6': '0', 
#賣價#8 	                    'AskVolume7': '0', 
#賣價#9 	                    'AskVolume8': '0', 
#賣價#10 	                    'AskVolume9': '0', 
#委託買進總筆數 	            'TotalBidCount': '57880', 
#委託買進總數量 	            'TotalBidVolume': '93622', 
#委託賣出總筆數 	            'TotalAskCount': '56531', 
#委託賣出總數量 	            'TotalAskVolume': '89091', 
#內盤量 	                    'BidSize': '58369', 
#外盤量 	                    'AskSize': '61200', 
#台灣期貨交易所衍伸一檔買量 	    'FirstDerivedBidVolume': '2', 
#台灣期貨交易所衍伸一檔賣量 	    'FirstDerivedAskVolume': '3', 
#累進買進成交筆數 	            'BuyCount': '57880', 
#累進賣出成交筆數 	            'SellCount': '56531', 
# 	                            'EndDate': '20220119', 
# 	                            'BestBidVolume': '14', 
# 	                            'BestAskVolume': '20', 
# 	                            'BeginDate': '20211021', 
# 	                            'YTradeDate': '0', 
# 	                            'ExpiryDate': '16', 
#成交價 	                    'TradingPrice': '18461', 
#漲跌 	                       'Change': '189', 
#累計成交量 	                'TradeVolume': '85581', 
# 	                            'OpeningPrice': '18350', 
# 	                            'HighPrice': '18497', 
# 	                            'LowPrice': '18350', 
# 	                            'ClosingPrice': '', 
#參考價 	                    'ReferencePrice': '18272', 
# 	                            'UpperLimitPrice': '20099', 
# 	                            'LowerLimitPrice': '16445', 
#昨收 	                        'YClosedPrice': '18365', 
#昨量 	                        'YTradeVolume': '44762', 
#買價#1 	                    'Bid': '18459', 
#買價#2 	                    'Bid1': '18458', 
#買價#3 	                    'Bid2': '18457', 
#買價#4 	                    'Bid3': '18457', 
#買價#5 	                    'Bid4': '18455', 
#買價#6 	                    'Bid5': '', 
#買價#7 	                    'Bid6': '', 
#買價#8 	                    'Bid7': '', 
#買價#9 	                    'Bid8': '', 
#買價#10 	                    'Bid9': '', 
#賣價#1 	                    'Ask': '18461', 
#賣價#2 	                    'Ask1': '18462', 
#賣價#3 	                    'Ask2': '18463', 
#賣價#4 	                    'Ask3': '18464', 
#賣價#5 	                    'Ask4': '18465', 
#賣價#6 	                    'Ask5': '', 
#賣價#7 	                    'Ask6': '', 
#賣價#8 	                    'Ask7': '', 
#賣價#9 	                    'Ask8': '', 
#賣價#10 	                    'Ask9': '', 
# 	                            'PreciseTime': '23305406000', 
#台灣期貨交易所衍伸一檔買價 	'FirstDerivedBid': '18456', 
#台灣期貨交易所衍伸一檔賣價 	'FirstDerivedAsk': '18463', 
# 	                            'SettlementPrice': '', 
# 	                            'BestBid': '18459', 
# 	                            'BestAsk': '18461', 
# 	                            'Deposit': '', 
# 	                            'TickSize': '', 
# 	                            'TradeStatus': '', 
# 	                            'OpenInterest': '0'
# }